#include <typeinfo>
#include "assignstatement.h"
using namespace std;

Ast& AssignStatement::operator = (const Ast& ast) {
	const AssignStatement& assignStatement = dynamic_cast<const AssignStatement&>(ast);

	Ast::operator=(ast);
	this->leftSideList = assignStatement.leftSideList ? dynamic_cast<LeftSideList*>(&(assignStatement.leftSideList->clone())) : 0;
	this->expressionList = assignStatement.expressionList ? dynamic_cast<ExpressionList*>(&(assignStatement.expressionList->clone())) : 0;

	return *(this);
}

bool AssignStatement::operator == (const Ast& ast) const {
	bool result = false;
	const AssignStatement& assignStatement = dynamic_cast<const AssignStatement&>(ast);

	if (typeid(ast) != typeid(AssignStatement))
		return false;

	if (this->leftSideList && this->expressionList)
		result = (*(this->leftSideList) == *(assignStatement.leftSideList) &&
				   *(this->expressionList) == *(assignStatement.expressionList));

	return result;
}

