#include "ast.h"


Ast::Ast(SrcPosition *position) {
	this->position = position;
}

Ast::Ast(const Ast& ast){
	(*this) = const_cast<Ast&>(ast);
}

Ast::~Ast(){
	delete this->position;
}

SrcPosition *Ast::getPosition() {
	return this->position;
}

void Ast::setPosition(SrcPosition *position){
	this->position = position;
}

Ast& Ast::operator = (const Ast& ast){
	this->position = new SrcPosition(*ast.position);
	return *this;
}

bool Ast::operator == (const Ast& ast) const{
	return (!this->position)? false : (*(this->position)) == *(ast.position);
}
