#include "ccodegeneratorvisitor.h"
#include "protomake.h"
#include <vector>
#include <typeinfo>
#include <cstdio>
using namespace std;

VisitorReturn *CCodeGeneratorVisitor::visitAction(Action *action) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitActStatement(ActStatement *actStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitArrayReference(ArrayReference *arrayReference) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitArrayType(ArrayType *arrayType) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitAssignStatement(AssignStatement *assignStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitAst(Ast *ast) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitBehavior(Behavior *behavior) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitBehaviorStatement(BehaviorStatement *behaviorStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitBinaryExpression(BinaryExpression *binaryExpression) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitDeclaration(Declaration *declaration) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitDoStatement(DoStatement *doStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitExpression(Expression *expression) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitExpressionList(ExpressionList *expressionList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitFieldDeclaration(FieldDeclaration *fieldDeclaration) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitFieldReference(FieldReference *fieldReference) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitFieldType(FieldType *fieldType) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitGuard(Guard *guard) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitGuardedStatement(GuardedStatement *guardedStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitGuardExpression(GuardExpression *guardExpression) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitGuardReceive(GuardReceive *guardReceive) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitGuardTimeout(GuardTimeout *guardTimeout) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitIdentifier(Identifier *identifier) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitIdentifierList(IdentifierList *identifierList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitIfStatement(IfStatement *ifStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitImport(Import *import) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitIntegerLiteral(IntegerLiteral *integerLiteral) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitLeftSide(LeftSide *leftSide) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitLeftSideList(LeftSideList *leftSideList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitMessage(Message *message) {
	VisitorReturn *v;
	
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitMultipleArrayReference(MultipleArrayReference *multipleArrayReference) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitProcess(Process *process) {
	VisitorReturn *v;
	return v;
}

// Terminado!
VisitorReturn *CCodeGeneratorVisitor::visitProgram(Program *program) {
	VisitorReturn *v = 0;
	char *name = new char[strlen(this->baseName) + strlen(this->baseDir) + 256];

	if(program->getImport())
		program->getImport()->visit(*this); // No est sendo considerado ainda
	if(program->getBehavior())
		program->getBehavior()->visit(*this); // No est sendo considerado ainda

	// Creating messages files!
	sprintf(name, "%s/%s_messages.h", baseDir, baseName);
	this->hFile.open(name);

	name[strlen(name) - 1] = 'c';
	this->cFile.open(name);

	if (hFile.is_open() && cFile.is_open()) {
		hFile << "/**\n * Messages file generated by ProtoMake 0.9 \n";
		hFile << " * Copyright 2003 Fabio Guerra, Igor Canana, Rodrigo Arajo &\n";
		hFile << " * Thiago Souto Maior.\n *\n";
		hFile << " * To contact the authors:\n";
		hFile << " *\tFabio   -> fga@cin.ufpe.br\n";
		hFile << " *\tIgor    -> icc@cin.ufpe.br\n";
		hFile << " *\tRodrigo -> rca4@cin.ufpe.br\n";
		hFile << " *\tThiago  -> tsmcf@cin.ufpe.br\n";
		hFile << " */\n\n";
		
		hFile << "#ifndef _MESSAGES_H_\n";
		hFile << "#define _MESSAGES_H_\n\n";
        
		hFile << "#include <netinet/in.h>\n";
		hFile << "#include <stdint.h>\n\n";

		hFile << "#ifndef _PM_BYTE_TYPE_\n";
		hFile << "#define _PM_BYTE_TYPE_\n";
		hFile << "\ttypedef unsigned char byte;\n";
		hFile << "#endif\n\n";

		cFile << "#include <string.h>\n";
		cFile << "#include <stdlib.h>\n";
		cFile << "#include \"messages.h\"\n\n";
	}
	else {
		cerr << "Unable to create messages.h and messages.c!\n";
		exit(1);
	}
	program->getMessage()->visit(*this); 
	hFile << "#endif\n";

	hFile.close();
	cFile.close();
	

// Creating process files!
//	this->hFile.open("./code/processes.h");
//	this->cFile.open("./code/processes.c");
//	this->cFile.open("./code/server.c");

/*
	if (hFile.is_open() && cFile.is_open()) {
		hFile << "/**\n * Processes file generated by ProtoMake 0.9 \n";
		hFile << " * Copyright 2003 Fabio Guerra, Igor Canana, Rodrigo Arajo &\n";
		hFile << " * Thiago Souto Maior.\n *\n";
		hFile << " * To contact the authors:\n";
		hFile << " *\tFabio   -> fga@cin.ufpe.br\n";
		hFile << " *\tIgor    -> icc@cin.ufpe.br\n";
		hFile << " *\tRodrigo -> rca4@cin.ufpe.br\n";
		hFile << " *\tThiago  -> tsmcf@cin.ufpe.br\n";
		hFile << " *\n\n"; // Lembrar de colocar uma barra depois do asterisco!
		
		hFile << "#ifndef _PROCESSES_H_\n";
		hFile << "#define _PROCESSES_H_\n\n";
        
		hFile << "#include <netinet/in.h>\n";
		hFile << "#include <stdint.h>\n";
		hFile << "#include \"lib/cpmthread.h\"\n";
		hFile << "#include \"lib/cpmsocket.h\"\n\n";

		hFile << "#ifndef _PM_BYTE_TYPE_\n";
		hFile << "#define _PM_BYTE_TYPE_\n";
		hFile << "\ttypedef unsigned char byte;\n";
		hFile << "#endif\n\n";
		
		hFile << "typedef void *(*thread)(void *args) funcPtr\n\n";
		hFile << "typedef struct {\n";
		hFile << "\tpmthread_t id;\n";
		hFile << "\tpmmutex_t mutex;\n";
		hFile << "\tpmcond_t cond;\n";
		hFile << "\tfuncPtr *funcs;\n";
		hFile << "} threadData;\n\n";
		
		cFile << "#include <string.h>\n";
		cFile << "#include <stdlib.h>\n";
		cFile << "#include \"messages.h\"\n\n"; 

// Escrita do servidor do cliente. GAMBIARRA temporria!!
		cFile << "#include \"cpmsocket.h\"\n";
		cFile << "#include \"messages.h\"\n\n";
		cFile << "int main(void)\n{\n";
		cFile << "\tPMSocket *server = pmsocket_open(\"127.0.0.1\", 9986, TCP);\n";
		cFile << "\tbyte buffer[14];\n\n";
		cFile << "\tpmsocket_accept(server, 10);\n";
		cFile << "\tpmsocket_recv(server, buffer, 14, NULL);\n";
		cFile << "\tpmsocket_close(server);\n\n";
		cFile << "\treturn 0;\n}\n";
		cFile.close();

		cFile.open("./code/client.c");
		if (cFile.is_open()) {
			cFile << "#include \"cpmsocket.h\"\n";
			cFile << "#include \"messages.h\"\n\n";
			cFile << "int main(void)\n{\n";
			cFile << "\tPMSocket *server = pmsocket_connect(\"127.0.0.1\", 9986);\n";
			cFile << "\tmessage_one msg;\n";
			cFile << "\tbyte *buffer;\n\n";
			cFile << "\tmsg.length = 10;\n\tmsg.msg = (byte *) malloc(msg.length);\n";
			cFile << "\tmemcpy(msg.msg, \"projeto-R2\", 10);\n";
			cFile << "\tmsg.flags = 3;\n";
			cFile << "\tbuffer = message_one_serialize(&msg, NULL);\n";
			cFile << "\tpmsocket_send(server, buffer, 14);\n";
			cFile << "\tpmsocket_close(server);\n\n";
			cFile << "\treturn 0;\n}\n";
		}
	}
	else {
		cerr << "Unable to create processes.h and processes.c!\n";
		exit(1);
	}
*/

	program->getProcess()->visit(*this);

	delete name;

	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitRangeType(RangeType *rangeType) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitReceiveStatement(ReceiveStatement *receiveStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSendStatement(SendStatement *sendStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialAction(SequentialAction *sequentialAction) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialBehavior(SequentialBehavior *sequentialBehavior) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialDeclaration(SequentialDeclaration *sequentialDeclaration) {
	VisitorReturn *v;

	sequentialDeclaration->getDeclaration()->visit(*this);
	sequentialDeclaration->getSimpleDeclaration()->visit(*this);
	
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialExpressionList(SequentialExpressionList *sequentialExpressionList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialFieldDeclaration(SequentialFieldDeclaration *sequentialFieldDeclaration) {
	VisitorReturn *v1, *v2;

	v1 = sequentialFieldDeclaration->getFieldDeclaration()->visit(*this);
	v2 = sequentialFieldDeclaration->getSimpleFieldDeclaration()->visit(*this);

	v1->fields.push_back(v2->fields[0]);
	
	return v1;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialGuardedStatement(SequentialGuardedStatement *sequentialGuardedStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialIdentifierList(SequentialIdentifierList *sequentialIdentifierList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialImport(SequentialImport *sequentialImport) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialLeftSideList(SequentialLeftSideList *sequentialLeftSideList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialMessage(SequentialMessage *sequentialMessage) {
	VisitorReturn *v = 0;

	sequentialMessage->getMessage()->visit(*this);
	sequentialMessage->getSimpleMessage()->visit(*this);
	
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialProcess(SequentialProcess *sequentialProcess) {
	VisitorReturn *v = 0;

	sequentialProcess->getProcess()->visit(*this);
	sequentialProcess->getSimpleProcess()->visit(*this);

	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSequentialStatement(SequentialStatement *sequentialStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleAction(SimpleAction *simpleAction) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleArrayReference(SimpleArrayReference *simpleArrayReference) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleBehavior(SimpleBehavior *simpleBehavior) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleDeclaration(SimpleDeclaration *simpleDeclaration) {
	VisitorReturn *v;

	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleExpressionList(SimpleExpressionList *simpleExpressionList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleFieldDeclaration(SimpleFieldDeclaration *simpleFieldDeclaration) {
	VisitorReturn *v = new VisitorReturn;
	v->fields.push_back(simpleFieldDeclaration);

	Expression *expr = simpleFieldDeclaration->getFieldType()->getExpression();

	hFile << "\t";
	if (typeid(*expr) == typeid(IntegerLiteral)) {
		if (simpleFieldDeclaration->getFieldType()->getType() == FieldType::BYTE)
			hFile << "byte *";
		
		else if (simpleFieldDeclaration->getFieldType()->getType() == FieldType::BIT) {
			IntegerLiteral *il = dynamic_cast<IntegerLiteral*> (expr);

			if (il->getValue() <= 8)
				hFile << "byte ";
			else if (il->getValue() <= 16)
				hFile << "uint16_t ";
			else if (il->getValue() <= 32)
				hFile << "uint32_t ";
		}
	}
	else if (typeid(*expr) == typeid(Identifier))
		hFile << "byte *";
	
	hFile << simpleFieldDeclaration->getIdentifier()->getName() << ";\n";
	
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleGuardedStatement(SimpleGuardedStatement *simpleGuardedStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleIdentifierList(SimpleIdentifierList *simpleIdentifierList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleImport(SimpleImport *simpleImport) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleLeftSideList(SimpleLeftSideList *simpleLeftSideList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleMessage(SimpleMessage *simpleMessage) {
	VisitorReturn *v;
	static int code = 1;
	string name = simpleMessage->getIdentifier()->getName();

// Generate correct header for the messages.c file!
	hFile << "typedef struct {\n";
	v = simpleMessage->getFieldDeclaration()->visit(*this);
	hFile << "} message_" << name << ";\n\n";

	hFile << "byte *message_" << name << "_serialize(const message_" << name;
	hFile << " *msg_" << name << ", byte *buffer);\n";

	hFile << "message_" << name << " *message_" << name << "_unserialize(";
	hFile << "const byte *buffer, message_" << name << " *msg_" << name << ");\n\n";
	

// Generate the implementation for the prototypes declared in message.h!
// Serialize the struct
	cFile << "byte *message_" << name << "_serialize(const message_" << name;
	cFile << " *msg_" << name << ", byte *buffer) {\n";

	cFile << "\tuint16_t code = htons(" << code << ");\n";
	cFile << "\tuint32_t offset = 0;\n";
    cFile << "\tuint16_t temp16 = 0;\n";
    cFile << "\tuint32_t temp32 = 0;\n";
	cFile << "\tbyte *buf;\n\n";
	cFile << "\tbuf = (byte *) malloc((";

// Allocate the correct size for the buffer
	for (vector<SimpleFieldDeclaration*>::iterator itr = v->fields.begin();
		 itr != v->fields.end();
		 itr++) {
		if (itr != v->fields.begin())
			cFile << " + ";
			
		Expression *expr = (*itr)->getFieldType()->getExpression();
    	
		if (typeid(*expr) == typeid(IntegerLiteral)) {
			IntegerLiteral *il = dynamic_cast<IntegerLiteral*> (expr);
			
			if ((*itr)->getFieldType()->getType() == FieldType::BYTE)
				cFile << il->getValue();
			
			else if ((*itr)->getFieldType()->getType() == FieldType::BIT) {
    	
				if (il->getValue() <= 8)
					cFile << "1";
				else if (il->getValue() <= 16)
					cFile << "2";
				else if (il->getValue() <= 32)
					cFile << "4";
			}
		}
		else if (typeid(*expr) == typeid(Identifier))
			cFile << "msg_" << name << "->" << (dynamic_cast<Identifier*> (expr))->getName();
	}
	cFile << ") * sizeof(byte));\n\n";
	cFile << "\tmemcpy(buf, &code, 2);\n";
	cFile << "\toffset = 2;\n\n";

	for (vector<SimpleFieldDeclaration*>::iterator itr = v->fields.begin();
		 itr != v->fields.end();
		 itr++) {
		Expression *expr = (*itr)->getFieldType()->getExpression();

		if (typeid(*expr) == typeid(IntegerLiteral)) {
			IntegerLiteral *il = dynamic_cast<IntegerLiteral*> (expr);
			
			if ((*itr)->getFieldType()->getType() == FieldType::BYTE) {
        		cFile << "\tmemcpy((buf + offset), ";
				cFile << "msg_" << name << "->" << (*itr)->getIdentifier()->getName();
				cFile << ", " << il->getValue() << ");\n"; 
				cFile << "\toffset += " << il->getValue() << ";\n\n";
			}
			
			else if ((*itr)->getFieldType()->getType() == FieldType::BIT) {
				if (il->getValue() > 8 && il->getValue() <= 16) {
					cFile << "\ttemp16 = htons(msg_" << name << "->" << (*itr)->getIdentifier()->getName();
                    cFile << ");\n";
                }
                
				else if (il->getValue() > 16 && il->getValue() <= 32) {
					cFile << "\ttemp32 = htonl(msg_" << name << "->" << (*itr)->getIdentifier()->getName();
                    cFile << ");\n";
                }
                
                cFile << "\tmemcpy((buf + offset), ";
    	
				if (il->getValue() <= 8) {
                    cFile << "&(msg_" << name << "->" << (*itr)->getIdentifier()->getName() << "), ";
					cFile << "1);\n\toffset += 1;\n\n";
                }
				else if (il->getValue() <= 16)
					cFile << "&temp16, 2);\n\toffset += 2;\n\n";
				else if (il->getValue() <= 32)
					cFile << "&temp32, 4);\n\toffset += 4;\n\n";
			}
		}
		else if (typeid(*expr) == typeid(Identifier)) {
            cFile << "\tmemcpy((buf + offset), ";
            cFile << "msg_" << name << "->" << (*itr)->getIdentifier()->getName() << ", ";
			cFile << "msg_" << name << "->" << (dynamic_cast<Identifier*> (expr))->getName() << ");\n";
			cFile << "\toffset += msg_" << name << "->";
			cFile << (dynamic_cast<Identifier*> (expr))->getName() << ";\n\n";
		}
	}
	cFile << "\tif (buffer != NULL) {\n";
	cFile << "\t\tmemmove(buffer, buf, offset);\n";
	cFile << "\t\tfree(buf);\n\t\tbuf = NULL;\n\t}\n\n";
	cFile << "\treturn buf;\n}\n\n";


// Unserialize the buffer
	cFile << "message_" << name << " *message_" << name << "_unserialize(";
	cFile << "const byte *buffer, message_" << name << " *msg_" << name << ") {\n";
	
	cFile << "\tmessage_" << name << " *msg = (message_" << name << " *) ";
	cFile << "malloc(sizeof(message_" << name << "));\n";
	cFile << "\tuint32_t offset = 2;\n\n";
	
	for (vector<SimpleFieldDeclaration*>::iterator itr = v->fields.begin();
		 itr != v->fields.end();
		 itr++) {
		Expression *expr = (*itr)->getFieldType()->getExpression();

		if (typeid(*expr) == typeid(IntegerLiteral)) {
			IntegerLiteral *il = dynamic_cast<IntegerLiteral*> (expr);
			
			if ((*itr)->getFieldType()->getType() == FieldType::BYTE) {
				cFile << "\tmemcpy(msg_" << name << "->" << (*itr)->getIdentifier()->getName();
				cFile << ", (buffer + offset), " << il->getValue() << ");\n"; 
				cFile << "\toffset += " << il->getValue() << ";\n\n";
			}
			
			else if ((*itr)->getFieldType()->getType() == FieldType::BIT) {
				cFile << "\tmemcpy(&(msg_" << name << "->" << (*itr)->getIdentifier()->getName();
				cFile << "), (buffer + offset), ";
    	
				if (il->getValue() <= 8)
					cFile << "1);\n\toffset += 1;\n\n";
				else if (il->getValue() <= 16) {
					cFile << "2);\n\toffset += 2;\n";
                    cFile << "\tmsg_" << name << "->" << (*itr)->getIdentifier()->getName() << " = ";
                    cFile << "ntohs(msg_" << name << "->" << (*itr)->getIdentifier()->getName() << ");\n\n";
                }
				else if (il->getValue() <= 32) {
					cFile << "4);\n\toffset += 4;\n";
                    cFile << "\tmsg_" << name << "->" << (*itr)->getIdentifier()->getName() << " = ";
                    cFile << "ntohl(msg_" << name << "->" << (*itr)->getIdentifier()->getName() << ");\n\n";
                }
			}
		}
		else if (typeid(*expr) == typeid(Identifier)) {
			cFile << "\tmemcpy(msg_" << name << "->" << (*itr)->getIdentifier()->getName();
			cFile << ", (buffer + offset), ";
			cFile << "msg_" << name << "->" << (dynamic_cast<Identifier*> (expr))->getName() << ");\n";
			cFile << "\toffset += msg_" << name << "->";
			cFile << (dynamic_cast<Identifier*> (expr))->getName() << ";\n\n";
		}
	}
	
	cFile << "\tif (msg_" << name << " != NULL) {\n";
	cFile << "\t\tmemmove(msg_" << name << ", msg, offset);\n";
	cFile << "\t\tfree(msg);\n\t\tmsg = NULL;\n\t}\n\n";
	cFile << "\treturn msg;\n}\n\n";
	
// Increment the code for the next message
	code++;
	
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleProcess(SimpleProcess *simpleProcess) {
	VisitorReturn *v = new VisitorReturn();
	string name = simpleProcess->getIdentifier()->getName();

	hFile << "typedef struct {\n";
	hFile << "\tthreadData data;\n";
	simpleProcess->getDeclaration()->visit(*this);
	hFile << "} processData;\n\n";
	
	hFile << "processData " << name << "_proc;\n";
	hFile << "processData " << name << "_recp;\n\n";
	
	hFile << "void *proc_" << name << "(void *args);\n";
	hFile << "void *recp_" << name << "(void *args);\n\n";
	
	
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSimpleStatement(SimpleStatement *simpleStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitSkipStatement(SkipStatement *skipStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitStartStatement(StartStatement *startStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitStatement(Statement *statement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitStopStatement(StopStatement *stopStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitStringLiteral(StringLiteral *stringLiteral) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitType(Type *type) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *CCodeGeneratorVisitor::visitUnaryExpression(UnaryExpression *unaryExpression) {
	VisitorReturn *v;
	return v;
}

