#include <typeinfo>
#include "guardtimeout.h"
using namespace std;

Ast& GuardTimeout::operator = (const Ast& ast) {
	const GuardTimeout& guardTimeout = dynamic_cast<const GuardTimeout&>(ast);

	Guard::operator=(ast);
	this->identifier = guardTimeout.identifier ? dynamic_cast<Identifier*>(&(guardTimeout.identifier->clone())) : 0;

	return *(this);
}

bool GuardTimeout::operator == (const Ast& ast) const {
	bool result = false;
	const GuardTimeout& guardTimeout = dynamic_cast<const GuardTimeout&>(ast);

	if (typeid(ast) != typeid(GuardTimeout))
		return false;

	if (this->identifier)
		result = (*(this->identifier) == *(guardTimeout.identifier));

	return result && Guard::operator==(ast);
}

