#include "javacodegeneratorvisitor.h"
#include "protomake.h"

VisitorReturn *JavaCodeGeneratorVisitor::visitAction(Action *action) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitActStatement(ActStatement *actStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitArrayReference(ArrayReference *arrayReference) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitArrayType(ArrayType *arrayType) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitAssignStatement(AssignStatement *assignStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitAst(Ast *ast) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitBehavior(Behavior *behavior) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitBehaviorStatement(BehaviorStatement *behaviorStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitBinaryExpression(BinaryExpression *binaryExpression) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitDeclaration(Declaration *declaration) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitDoStatement(DoStatement *doStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitExpression(Expression *expression) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitExpressionList(ExpressionList *expressionList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitFieldDeclaration(FieldDeclaration *fieldDeclaration) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitFieldReference(FieldReference *fieldReference) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitFieldType(FieldType *fieldType) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitGuard(Guard *guard) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitGuardedStatement(GuardedStatement *guardedStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitGuardExpression(GuardExpression *guardExpression) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitGuardReceive(GuardReceive *guardReceive) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitGuardTimeout(GuardTimeout *guardTimeout) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitIdentifier(Identifier *identifier) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitIdentifierList(IdentifierList *identifierList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitIfStatement(IfStatement *ifStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitImport(Import *import) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitIntegerLiteral(IntegerLiteral *integerLiteral) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitLeftSide(LeftSide *leftSide) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitLeftSideList(LeftSideList *leftSideList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitMessage(Message *message) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitMultipleArrayReference(MultipleArrayReference *multipleArrayReference) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitProcess(Process *process) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitProgram(Program *program) {
	VisitorReturn *v;
	string nome = baseDir;
	nome = nome + "/" + baseName;
	output.open(nome.c_str());
	if(!output.is_open()) {
		cerr << "Falha ao tentar abrir arquivo: " << nome << endl;
		return v;
	}
	output << "import java.io.*;\nimport java.net.*;\n\n\n";
	program->getMessage()->visit(*this);
	output.close();
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitRangeType(RangeType *rangeType) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitReceiveStatement(ReceiveStatement *receiveStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSendStatement(SendStatement *sendStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialAction(SequentialAction *sequentialAction) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialBehavior(SequentialBehavior *sequentialBehavior) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialDeclaration(SequentialDeclaration *sequentialDeclaration) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialExpressionList(SequentialExpressionList *sequentialExpressionList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialFieldDeclaration(SequentialFieldDeclaration *sequentialFieldDeclaration) {
	VisitorReturn *v;
	sequentialFieldDeclaration->getFieldDeclaration()->visit(*this);
	sequentialFieldDeclaration->getSimpleFieldDeclaration()->visit(*this);
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialGuardedStatement(SequentialGuardedStatement *sequentialGuardedStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialIdentifierList(SequentialIdentifierList *sequentialIdentifierList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialImport(SequentialImport *sequentialImport) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialLeftSideList(SequentialLeftSideList *sequentialLeftSideList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialMessage(SequentialMessage *sequentialMessage) {
	VisitorReturn *v;
	sequentialMessage->getMessage()->visit(*this);
	sequentialMessage->getSimpleMessage()->visit(*this);
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialProcess(SequentialProcess *sequentialProcess) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSequentialStatement(SequentialStatement *sequentialStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleAction(SimpleAction *simpleAction) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleArrayReference(SimpleArrayReference *simpleArrayReference) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleBehavior(SimpleBehavior *simpleBehavior) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleDeclaration(SimpleDeclaration *simpleDeclaration) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleExpressionList(SimpleExpressionList *simpleExpressionList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleFieldDeclaration(SimpleFieldDeclaration *simpleFieldDeclaration) {
	VisitorReturn *v;	
	string name = simpleFieldDeclaration->getIdentifier()->getName();
	string type;
	
	this->stack.push_back(simpleFieldDeclaration);
	
	if(simpleFieldDeclaration->getFieldType()->getType() == FieldType::BYTE) {
		type = "byte[]";
	} else {
		int value = ((IntegerLiteral*)simpleFieldDeclaration->getFieldType()->getExpression())->getValue();
		if(value <= 8) {
			type = "byte";
		} else if(value <= 16) {
			type = "short";
		} else {
			type = "int";
		}
	}
	output << "\tprivate " << type << " " << name << ";\n\n"; 
	
	/**
	 * Set from a unicode string
	 * Falta fazer!!
	 */
	if(type == "byte[]") {
		output << "\tpublic void set" << name << "(String " << name << ") {\n";
		output << "\t}\n\n";
	}
	
	/**
	 * Method set
	 */
	output << "\tpublic void set" << name << "(" << type << " " << name << ") {\n";
	output << "\t\tthis." << name << " = " << name << ";\n\t}\n\n";
	
	/**
	 * Method Get
	 */
	output << "\tpublic " << type << " get" << name << "() {\n\t\treturn this." << name << ";\n\t}\n\n";

	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleGuardedStatement(SimpleGuardedStatement *simpleGuardedStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleIdentifierList(SimpleIdentifierList *simpleIdentifierList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleImport(SimpleImport *simpleImport) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleLeftSideList(SimpleLeftSideList *simpleLeftSideList) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleMessage(SimpleMessage *simpleMessage) {
	VisitorReturn *v;
	this->msgCode++;
	/**/
	output << "/**\n *\n */\n class Message" << simpleMessage->getIdentifier()->getName() <<
				 " {\n";
	output << "\tpublic static final short CODE = " << this->msgCode << ";\n";
	this->stack.clear();
	simpleMessage->getFieldDeclaration()->visit(*this);

	string linha1 = "\t\t\tdataOS.writeShort(CODE);\n";
	string linha2 = "\t\t\tdataIS.readShort();\n";
        int size = 2;
        string campoByte;
	for(vector<Ast*>::iterator i = this->stack.begin(); i != this->stack.end(); i++) {
		SimpleFieldDeclaration& fdecl = dynamic_cast<SimpleFieldDeclaration&>(**i);
		string name = fdecl.getIdentifier()->getName();
		linha1 += "\t\t\tdataOS.write";

		if(fdecl.getFieldType()->getType() == FieldType::BYTE) {
			linha1 += "(this." + name + ", 0, this." + name + ".length);\n";
			linha2 += "\t\t\tdataIS.readFully(this." + name + ");\n";
			campoByte += " + this." + name + ".length";
		} else {
			int value = ((IntegerLiteral*)fdecl.getFieldType()->getExpression())->getValue();
			linha2 += "\t\t\tthis." + name + " = dataIS.read";
			if(value <= 8) {
				linha1 += "Byte(this." + name + ");\n";
				linha2 += "Byte();\n";
				size += 1;
			} else if(value <= 16) {
				linha1 += "Short(this." + name + ");\n";
				linha2 += "Short();\n";
				size += 2;
			} else {
				linha1 += "Int(this." + name + ");\n";
				linha2 += "Int();\n";
				size += 4;
			}
		}

	}

	/**
	 * Serialize...
	 */
	output << "\tpublic byte[] serialize() {\n";
	output << "\t\tByteArrayOutputStream byteOS = null;\n";
	output << "\t\tDataOutputStream dataOS = null;\n\t\thandleOut();\n\t\ttry{\n";
	output << "\t\t\tbyteOS = new ByteArrayOutputStream();\n\t\t\tdataOS = new DataOutputStream(byteOS);\n\n";
	output << linha1;
	output << "\t\t\t\n";
	output << "\t\t} catch(Exception e) {e.printStackTrace();}\n";
	output << "\t\treturn byteOS.toByteArray();\n";
	output << "\t}\n\n";

	/**
	 * Unserialize
	 */
	output << "\tpublic void unserialize(byte[] array) {\n";
	output << "\t\tByteArrayInputStream byteIS = null;\n";
	output << "\t\tDataInputStream dataIS = null;\n\t\ttry{\n";
	output << "\t\t\tbyteIS = new ByteArrayInputStream(array);\n\t\t\tdataIS = new DataInputStream(byteIS);\n\n";
	output << linha2;
	output << "\t\t\t\n";
	output << "\t\t} catch(Exception e) {e.printStackTrace();}\n";
	output << "\t\thandleIn();\n";
	output << "\t}\n\n";


	/**
	 * HandleOut
	 */
	string call;
	if(simpleMessage->getHandlerOut()) {
		call = simpleMessage->getHandlerOut()->getName() + "();\n\t}\n\n";
	} else {
		call = "\n\t}\n\n";
	}
	output << "\tprivate void handleOut() {\n\t\t" << call;

	/**
	 * HandleIn
	 */
	if(simpleMessage->getHandlerIn()) {
		call = simpleMessage->getHandlerIn()->getName() + "();\n\t}\n\n";
	} else {
		call = "\n\t}\n\n";
	}
	output << "\tprivate void handleIn() {\n\t\t" << call;

	output << "\tpublic int getSize() {\n\t\treturn " << size << campoByte << ";\n\t}\n";

        
	output << "}\n";
	
	if(this->msgCode == 1) {
	string one = simpleMessage->getIdentifier()->getName();
        output << "\nclass Process {\n" <<
	"\tpublic void processClient() {\n" <<
                "\t\ttry {\n" <<
		"\t\t\tMessage" << one << " m = new Message" << one << "();\n" <<
		"\t\t\tSocket s = new Socket(\"127.0.0.1\", 100);\n" <<
		"\t\t\tbyte[] msg = m.serialize();\n\n" <<
		"\t\t\ts.getOutputStream().write(msg, 0, msg.length);\n" <<
		"\t\t\ts.close();\n" <<
                "\t\t} catch(Exception e){e.printStackTrace();}\n" <<
	"\t}\n\n" <<
	"\tpublic void processServer() {\n" <<
               "\t\ttry {\n" <<
               "\t\tMessage" << one << " m = new Message" << one << "();\n" <<
               "\t\tServerSocket s = new ServerSocket(100);\n" <<
               "\t\tSocket c = s.accept();\n" <<
               "\t\tbyte[] code = new byte[256];\n" <<
               "\t\tc.getInputStream().read(code, 0, 2);\n" <<
               "\t\tif(code[1] == m.CODE){\n" <<
               "\t\tc.getInputStream().read(code, 2, m.getSize() - 2);\n" <<
               "\t}\n" <<
               "\tm.unserialize(code);" <<
               "\t} catch(Exception e){e.printStackTrace();}" <<
        "}\n\n}\n";
        }       

	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleProcess(SimpleProcess *simpleProcess) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSimpleStatement(SimpleStatement *simpleStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitSkipStatement(SkipStatement *skipStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitStartStatement(StartStatement *startStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitStatement(Statement *statement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitStopStatement(StopStatement *stopStatement) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitStringLiteral(StringLiteral *stringLiteral) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitType(Type *type) {
	VisitorReturn *v;
	return v;
}

VisitorReturn *JavaCodeGeneratorVisitor::visitUnaryExpression(UnaryExpression *unaryExpression) {
	VisitorReturn *v;
	return v;
}

