#ifndef PROTOMAKE_H
#define PROTOMAKE_H

#include "action.h"
#include "actstatement.h"
#include "arrayreference.h"
#include "arraytype.h"
#include "assignstatement.h"
#include "ast.h"
#include "behavior.h"
#include "behaviorstatement.h"
#include "binaryexpression.h"
#include "ccodegeneratorvisitor.h"
#include "declaration.h"
#include "dostatement.h"
#include "expression.h"
#include "expressionlist.h"
#include "fielddeclaration.h"
#include "fieldreference.h"
#include "fieldtype.h"
#include "guard.h"
#include "guardedstatement.h"
#include "guardexpression.h"
#include "guardreceive.h"
#include "guardtimeout.h"
#include "identifier.h"
#include "identifierlist.h"
#include "ifstatement.h"
#include "import.h"
#include "integerliteral.h"
#include "javacodegeneratorvisitor.h"
#include "leftside.h"
#include "leftsidelist.h"
#include "message.h"
#include "multiplearrayreference.h"
#include "process.h"
#include "program.h"
#include "rangetype.h"
#include "receivestatement.h"
#include "sendstatement.h"
#include "sequentialaction.h"
#include "sequentialbehavior.h"
#include "sequentialdeclaration.h"
#include "sequentialexpressionlist.h"
#include "sequentialfielddeclaration.h"
#include "sequentialguardedstatement.h"
#include "sequentialidentifierlist.h"
#include "sequentialimport.h"
#include "sequentialleftsidelist.h"
#include "sequentialmessage.h"
#include "sequentialprocess.h"
#include "sequentialstatement.h"
#include "simpleaction.h"
#include "simplearrayreference.h"
#include "simplebehavior.h"
#include "simpledeclaration.h"
#include "simpleexpressionlist.h"
#include "simplefielddeclaration.h"
#include "simpleguardedstatement.h"
#include "simpleidentifierlist.h"
#include "simpleimport.h"
#include "simpleleftsidelist.h"
#include "simplemessage.h"
#include "simpleprocess.h"
#include "simplestatement.h"
#include "skipstatement.h"
#include "srcposition.h"
#include "startstatement.h"
#include "statement.h"
#include "stopstatement.h"
#include "stringliteral.h"
#include "type.h"
#include "typecheckervisitor.h"
#include "unaryexpression.h"
#include "visitor.h"
#include "visitorreturn.h"

#endif
