#include <typeinfo>
#include "simpleimport.h"
using namespace std;

Ast& SimpleImport::operator = (const Ast& ast) {
	const SimpleImport& simpleImport = dynamic_cast<const SimpleImport&>(ast);

	Import::operator=(ast);
	this->stringLiteral = simpleImport.stringLiteral ? dynamic_cast<StringLiteral*>(&(simpleImport.stringLiteral->clone())) : 0;

	return *(this);
}

bool SimpleImport::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleImport& simpleImport = dynamic_cast<const SimpleImport&>(ast);

	if (typeid(ast) != typeid(SimpleImport))
		return false;

	if (this->stringLiteral)
		result = (*(this->stringLiteral) == *(simpleImport.stringLiteral));

	return result && Import::operator==(ast);
}

