#include <typeinfo>
#include "arraytype.h"
using namespace std;

Ast& ArrayType::operator = (const Ast& ast) {
	const ArrayType& arrayType = dynamic_cast<const ArrayType&>(ast);

	Type::operator=(ast);
	this->type = arrayType.type ? dynamic_cast<Type*>(&(arrayType.type->clone())) : 0;
	this->size = arrayType.size;

	return *(this);
}

bool ArrayType::operator == (const Ast& ast) const {
	bool result = false;
	const ArrayType& arrayType = dynamic_cast<const ArrayType&>(ast);

	if (typeid(ast) != typeid(ArrayType))
		return false;

	if (this->type)
		result = (*(this->type) == *(arrayType.type) &&
				  this->size == arrayType.size);

	return result && Type::operator==(ast);
}

