#include <typeinfo>
#include "dostatement.h"
using namespace std;

Ast& DoStatement::operator = (const Ast& ast) {
	const DoStatement& doStatement = dynamic_cast<const DoStatement&>(ast);

	Ast::operator=(ast);
	this->guardedStatement = doStatement.guardedStatement ? dynamic_cast<GuardedStatement*>(&(doStatement.guardedStatement->clone())) : 0;

	return *(this);
}

bool DoStatement::operator == (const Ast& ast) const {
	bool result = false;
	const DoStatement& doStatement = dynamic_cast<const DoStatement&>(ast);

	if (typeid(ast) != typeid(DoStatement))
		return false;

	if (this->guardedStatement)
		result = (*(this->guardedStatement) == *(doStatement.guardedStatement));

	return result;
}

