#include <typeinfo>
#include "fieldtype.h"
using namespace std;

Ast& FieldType::operator = (const Ast& ast) {
	const FieldType& fieldType = dynamic_cast<const FieldType&>(ast);

	Ast::operator=(ast);
	this->expression = this->expression ? dynamic_cast<Expression*>(&(fieldType.expression->clone())) : 0;
	this->type = fieldType.type;

	return *(this);
}

bool FieldType::operator == (const Ast& ast) const {
	bool result = false;
	const FieldType& fieldType = dynamic_cast<const FieldType&>(ast);

	if (typeid(ast) != typeid(FieldType))
		return false;

	if (this->expression)
		result = (*(this->expression) == *(fieldType.expression)) && (this->type == fieldType.type);

	return result && Ast::operator==(ast);
}

