#include <typeinfo>
#include "guardreceive.h"
using namespace std;

Ast& GuardReceive::operator = (const Ast& ast) {
	const GuardReceive& guardReceive = dynamic_cast<const GuardReceive&>(ast);

	Guard::operator=(ast);
	this->receiveStatement = guardReceive.receiveStatement ? dynamic_cast<ReceiveStatement*>(&(guardReceive.receiveStatement->clone())) : 0;

	return *(this);
}

bool GuardReceive::operator == (const Ast& ast) const {
	bool result = false;
	const GuardReceive& guardReceive = dynamic_cast<const GuardReceive&>(ast);

	if (typeid(ast) != typeid(GuardReceive))
		return false;

	if (this->receiveStatement)
		result = (*(this->receiveStatement) == *(guardReceive.receiveStatement));

	return result && Guard::operator==(ast);
}

