#include <typeinfo>
#include "ifstatement.h"
using namespace std;

Ast& IfStatement::operator = (const Ast& ast) {
	const IfStatement& ifStatement = dynamic_cast<const IfStatement&>(ast);

	Ast::operator=(ast);
	this->guardedStatement = ifStatement.guardedStatement ? dynamic_cast<GuardedStatement*>(&(ifStatement.guardedStatement->clone())) : 0;

	return *(this);
}

bool IfStatement::operator == (const Ast& ast) const {
	bool result = false;
	const IfStatement& ifStatement = dynamic_cast<const IfStatement&>(ast);

	if (typeid(ast) != typeid(IfStatement))
		return false;

	if (this->guardedStatement)
		result = (*(this->guardedStatement) == *(ifStatement.guardedStatement));

	return result;
}

