#include "integerliteral.h"

Ast& IntegerLiteral::operator = (const Ast& ast) {
	const IntegerLiteral& integerLiteral = dynamic_cast<const IntegerLiteral&>(ast);

	Expression::operator=(ast);
	this->value = integerLiteral.value;

	return (*this);
}


bool IntegerLiteral::operator == (const Ast& ast) const {
	const IntegerLiteral& integerLiteral = dynamic_cast<const IntegerLiteral&>(ast);
	return this->value == integerLiteral.value && Expression::operator==(ast);
}
