#include <typeinfo>
#include "simpleexpressionlist.h"
using namespace std;

Ast& SimpleExpressionList::operator = (const Ast& ast) {
	const SimpleExpressionList& simpleExpressionList = dynamic_cast<const SimpleExpressionList&>(ast);

	ExpressionList::operator=(ast);
	this->expression = simpleExpressionList.expression ? dynamic_cast<Expression*>(&(simpleExpressionList.expression->clone())) : 0;

	return *(this);
}

bool SimpleExpressionList::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleExpressionList& simpleExpressionList = dynamic_cast<const SimpleExpressionList&>(ast);

	if (typeid(ast) != typeid(SimpleExpressionList))
		return false;

	if (this->expression)
		result = (*(this->expression) == *(simpleExpressionList.expression));

	return result && ExpressionList::operator==(ast);
}

