#include "stringliteral.h"

Ast& StringLiteral::operator = (const Ast& ast) {
	const StringLiteral& stringLiteral = dynamic_cast<const StringLiteral&>(ast);

	Expression::operator=(ast);
	this->str = stringLiteral.str;

	return (*this);
}


bool StringLiteral::operator == (const Ast& ast) const {
	const StringLiteral& stringLiteral = dynamic_cast<const StringLiteral&>(ast);
	return this->str == stringLiteral.str && Expression::operator==(ast);
}
