#include <typeinfo>
#include "unaryexpression.h"
using namespace std;

Ast& UnaryExpression::operator = (const Ast& ast) {
	const UnaryExpression& unaryExpression = dynamic_cast<const UnaryExpression&>(ast);

	Ast::operator=(ast);
	this->expression = this->expression ? dynamic_cast<Expression*>(&(unaryExpression.expression->clone())) : 0;
	this->op = unaryExpression.op;

	return *(this);
}

bool UnaryExpression::operator == (const Ast& ast) const {
	bool result = false;
	const UnaryExpression& unaryExpression = dynamic_cast<const UnaryExpression&>(ast);

	if (typeid(ast) != typeid(UnaryExpression))
		return false;

	if (this->expression)
		result = (*(this->expression) == *(unaryExpression.expression));

	return result && (this->op == unaryExpression.op) && Ast::operator==(ast);
}

