# Este  um exemplo de um protocolo que pode tratar mais de um cliente
# por vez.  um servidor de echo modificado. Ele ecoa a mensagem na
# sua forma encriptada de volta ao cliente.

!@Author "Igor Chaves Cananea"
!@Email "icc@cin.ufpe.br"
!@Name "ProtoMake Crypt Protocol"
!@Acrynom "PCP"
!@Port 9986
!@Transport tcp

message text
begin
	length : 8 bits,
	msg : length bytes
end

behavior Crypt

process main
var client : server_address
begin
    rcv text from client -> start cryptMsg
end

process cryptMsg
var client : address;
const started : integer = 1
begin
	started = 1 -> Crypt.encrypt(text.msg, text.length);
				   if text.length <> 0 ->
				       send text to client
				   [] text.length = 0 ->
					   text.msg := "error";
				       text.length := 5;
					   send text to client
				   fi;
				   stop
end
